﻿class classes.CGame
{
	var stars;
	var player;
	var ammomanager;
	var ennemymanager;
	var decomanager;
	var dogame;
	var points;
	var glastmove;
	var LevelPoints;
	var CurrentLevel;

	public function CGame(){
		trace("initiating game engine...");		
		this.stars = new classes.CStars();
		this.player = new classes.CPlayer();
		this.dogame = false;
		this.points = 0;		
		this.glastmove = getTimer();
	}
	
	public function Start(){
		this.dogame = true;
	}
	
	public function LoadLevel(l:Number){
		trace("Loading level "+l);
		this.CurrentLevel = l;
		_root.level.text = this.CurrentLevel;
		this.ammomanager.clear();
		this.decomanager.clear();
		this.ennemymanager.clear();
		this.stars.clear();
		
		if(l>2)
			this.decomanager = new classes.CDecoManager();

		this.ammomanager = new classes.CAmmoManager();
		this.ennemymanager = new classes.CEnnemyManager();		
		this.stars = new classes.CStars();
		this.LevelPoints = this.CurrentLevel * 60;
	}
	
	public function DoFrame(){
		if(this.dogame){
			this.ammomanager.DoFrame();
			this.ennemymanager.DoFrame();
			this.decomanager.DoFrame();
			_root.points.text = this.points;
			if(this.player.Life<=0)
			{
				this.dogame = false;
				_root.loosed._visible = true;
			}
			if(this.points > this.LevelPoints){
				this.CurrentLevel++;
				this.dogame = false;
				this.LoadLevel(this.CurrentLevel);
				this.Start();
				this.points = 0;
			}
		}
		this.stars.DoFrame(this);
		if (this.glastmove+10000 < getTimer()){
			_root.space.galax._x --;
		}
	}
	
	public function GetMouse(){
		if(_root.space._xmouse > 0 && _root.space._ymouse > 0)
			this.player.Move(_root.space._xmouse,_root.space._ymouse);
	}
	
	public function MouseDown(){
		this.player.Fire();
	}
}